import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Lesson, LessonParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询课程管理
 */
export async function pageLesson(params: LessonParam) {
  const res = await request.get<ApiResult<PageResult<Lesson>>>(
    MODULES_API_URL + '/booking/lesson/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询课程管理列表
 */
export async function listLesson(params?: LessonParam) {
  const res = await request.get<ApiResult<Lesson[]>>(
    MODULES_API_URL + '/booking/lesson',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加课程管理
 */
export async function addLesson(data: Lesson) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/lesson',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改课程管理
 */
export async function updateLesson(data: Lesson) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/lesson',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除课程管理
 */
export async function removeLesson(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/lesson/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除课程管理
 */
export async function removeBatchLesson(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/lesson/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询课程管理
 */
export async function getLesson(id: number) {
  const res = await request.get<ApiResult<Lesson>>(
    MODULES_API_URL + '/booking/lesson/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
